_UART1_Interrupt:
;UART1.c,29 :: 		void UART1_Interrupt() iv IVT_UART_1 ilevel 7 ics ICS_AUTO {
RDPGPR	SP, SP
ADDIU	SP, SP, -16
SW	R30, 12(SP)
MFC0	R30, 12, 2
SW	R30, 8(SP)
MFC0	R30, 14, 0
SW	R30, 4(SP)
MFC0	R30, 12, 0
SW	R30, 0(SP)
INS	R30, R0, 1, 15
ORI	R30, R0, 7168
MTC0	R30, 12, 0
;UART1.c,33 :: 		if (URXDA_bit){
_LX	, 4
EXT	R2, R2, BitPos(URXDA_bit+0), 1
BNE	R2, R0, L__UART1_Interrupt33
NOP	
J	L_UART1_Interrupt0
NOP	
L__UART1_Interrupt33:
;UART1.c,34 :: 		R_data = U1RXREG;              // Fetch a byte from receive register
; R_data start address is: 16 (R4)
LW	R4, Offset(U1RXREG+0)(GP)
;UART1.c,36 :: 		RxQ.RxQueue[RxQ.RxIn++] = R_data;      // Put it into the recirculating buffer
LH	R3, Offset(_RxQ+0)(GP)
LUI	R2, #hi_addr(_RxQ+4)
ORI	R2, R2, #lo_addr(_RxQ+4)
ADDU	R2, R2, R3
SB	R4, 0(R2)
; R_data end address is: 16 (R4)
LH	R2, Offset(_RxQ+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_RxQ+0)(GP)
;UART1.c,37 :: 		if (RxQ.RxIn > (rxqsize-1))    // Adjust pointer if necessary
SEH	R2, R2
SLTI	R2, R2, 64
BEQ	R2, R0, L__UART1_Interrupt34
NOP	
J	L_UART1_Interrupt1
NOP	
L__UART1_Interrupt34:
;UART1.c,38 :: 		RxQ.RxIn = 0;
SH	R0, Offset(_RxQ+0)(GP)
L_UART1_Interrupt1:
;UART1.c,39 :: 		U1RXIF_bit = 0;                // Clear the receive interrupt flag
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	8, Offset(U1RXIF_bit+4), 4
;UART1.c,41 :: 		}else{
J	L_UART1_Interrupt2
NOP	
L_UART1_Interrupt0:
;UART1.c,42 :: 		T_data = XmtBuf[XmtBufPtr++];  // Get a byte from the transmit buffer
LBU	R3, Offset(_XmtBufPtr+0)(GP)
LW	R2, Offset(_XmtBuf+0)(GP)
ADDU	R2, R2, R3
LBU	R3, 0(R2)
; T_data start address is: 16 (R4)
ANDI	R4, R3, 255
LBU	R2, Offset(_XmtBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_XmtBufPtr+0)(GP)
;UART1.c,43 :: 		if (T_data == NUL){            // If it is the end of message marker
ANDI	R2, R3, 255
BEQ	R2, R0, L__UART1_Interrupt35
NOP	
J	L_UART1_Interrupt3
NOP	
L__UART1_Interrupt35:
; T_data end address is: 16 (R4)
;UART1.c,44 :: 		U1TXIE_bit = 0;             // Disable transmitter interrupts
LUI	R2, BitMask(U1TXIE_bit+0)
ORI	R2, R2, BitMask(U1TXIE_bit+0)
_SX	8, Offset(U1TXIE_bit+4), 4
;UART1.c,45 :: 		}else{
J	L_UART1_Interrupt4
NOP	
L_UART1_Interrupt3:
;UART1.c,46 :: 		U1TXREG = T_data;           // Transfer data byte to transmit register
; T_data start address is: 16 (R4)
ANDI	R2, R4, 255
; T_data end address is: 16 (R4)
SW	R2, Offset(U1TXREG+0)(GP)
;UART1.c,47 :: 		U1TXIF_bit = 0;             // Clear transmit interrupt flag
LUI	R2, BitMask(U1TXIF_bit+0)
ORI	R2, R2, BitMask(U1TXIF_bit+0)
_SX	8, Offset(U1TXIF_bit+4), 4
;UART1.c,48 :: 		}
L_UART1_Interrupt4:
;UART1.c,49 :: 		}
L_UART1_Interrupt2:
;UART1.c,50 :: 		}
L_end_UART1_Interrupt:
DI	
EHB	
LW	R30, 8(SP)
MTC0	R30, 12, 2
LW	R30, 4(SP)
MTC0	R30, 14, 0
LW	R30, 0(SP)
MTC0	R30, 12, 0
LW	R30, 12(SP)
ADDIU	SP, SP, 16
WRPGPR	SP, SP
ERET	
; end of _UART1_Interrupt
_UART1_SetBaud:
;UART1.c,54 :: 		void UART1_SetBaud(void){
;UART1.c,56 :: 		U1BRG = 520;
ORI	R2, R0, 520
SW	R2, Offset(U1BRG+0)(GP)
;UART1.c,57 :: 		}
L_end_UART1_SetBaud:
JR	RA
NOP	
; end of _UART1_SetBaud
_UART1_StartRx:
;UART1.c,61 :: 		void UART1_StartRx(void){
;UART1.c,62 :: 		ON__U1MODE_bit = 1; // Enable UART1 circuit
LUI	R2, BitMask(ON__U1MODE_bit+0)
ORI	R2, R2, BitMask(ON__U1MODE_bit+0)
_SX	8, Offset(ON__U1MODE_bit+8), 4
;UART1.c,63 :: 		URXEN_bit = 1;      // Enable receiver
LUI	R2, BitMask(URXEN_bit+0)
ORI	R2, R2, BitMask(URXEN_bit+0)
_SX	8, Offset(URXEN_bit+8), 4
;UART1.c,65 :: 		U1IP0_bit = 0;      // Set UART1 priority
LUI	R2, BitMask(U1IP0_bit+0)
ORI	R2, R2, BitMask(U1IP0_bit+0)
_SX	8, Offset(U1IP0_bit+4), 4
;UART1.c,66 :: 		U1IP1_bit = 1;
LUI	R2, BitMask(U1IP1_bit+0)
ORI	R2, R2, BitMask(U1IP1_bit+0)
_SX	8, Offset(U1IP1_bit+8), 4
;UART1.c,67 :: 		U1IP2_bit = 1;
LUI	R2, BitMask(U1IP2_bit+0)
ORI	R2, R2, BitMask(U1IP2_bit+0)
_SX	8, Offset(U1IP2_bit+8), 4
;UART1.c,68 :: 		U1IS1_bit = 1;      // Set UART1 sub-priority
LUI	R2, BitMask(U1IS1_bit+0)
ORI	R2, R2, BitMask(U1IS1_bit+0)
_SX	8, Offset(U1IS1_bit+8), 4
;UART1.c,69 :: 		U1IS0_bit = 1;
LUI	R2, BitMask(U1IS0_bit+0)
ORI	R2, R2, BitMask(U1IS0_bit+0)
_SX	8, Offset(U1IS0_bit+8), 4
;UART1.c,71 :: 		URXISEL0_bit = 0;   // Interrupt when buffer is not empty
LUI	R2, BitMask(URXISEL0_bit+0)
ORI	R2, R2, BitMask(URXISEL0_bit+0)
_SX	8, Offset(URXISEL0_bit+4), 4
;UART1.c,72 :: 		URXISEL1_bit = 0;
LUI	R2, BitMask(URXISEL1_bit+0)
ORI	R2, R2, BitMask(URXISEL1_bit+0)
_SX	8, Offset(URXISEL1_bit+4), 4
;UART1.c,74 :: 		U1RXIF_bit = 0;     // Clear the receive interrupt flag
LUI	R2, BitMask(U1RXIF_bit+0)
ORI	R2, R2, BitMask(U1RXIF_bit+0)
_SX	8, Offset(U1RXIF_bit+4), 4
;UART1.c,75 :: 		U1RXIE_bit = 1;     // Enable receiver interrupts
LUI	R2, BitMask(U1RXIE_bit+0)
ORI	R2, R2, BitMask(U1RXIE_bit+0)
_SX	8, Offset(U1RXIE_bit+8), 4
;UART1.c,76 :: 		}
L_end_UART1_StartRx:
JR	RA
NOP	
; end of _UART1_StartRx
_UART1_StartTx:
;UART1.c,80 :: 		void UART1_StartTx(void){
;UART1.c,81 :: 		UTXEN_bit = 1;      // Enable transmitter
LUI	R2, BitMask(UTXEN_bit+0)
ORI	R2, R2, BitMask(UTXEN_bit+0)
_SX	8, Offset(UTXEN_bit+8), 4
;UART1.c,83 :: 		UTXISEL0_bit = 0;   // Interrupt when transmit buffer is empty
LUI	R2, BitMask(UTXISEL0_bit+0)
ORI	R2, R2, BitMask(UTXISEL0_bit+0)
_SX	8, Offset(UTXISEL0_bit+4), 4
;UART1.c,84 :: 		UTXISEL1_bit = 1;
LUI	R2, BitMask(UTXISEL1_bit+0)
ORI	R2, R2, BitMask(UTXISEL1_bit+0)
_SX	8, Offset(UTXISEL1_bit+8), 4
;UART1.c,86 :: 		U1TXIF_bit = 0;     // Clear transmit interrupt flag
LUI	R2, BitMask(U1TXIF_bit+0)
ORI	R2, R2, BitMask(U1TXIF_bit+0)
_SX	8, Offset(U1TXIF_bit+4), 4
;UART1.c,87 :: 		U1TXIE_bit = 1;     // Enable transmitter interrupts
LUI	R2, BitMask(U1TXIE_bit+0)
ORI	R2, R2, BitMask(U1TXIE_bit+0)
_SX	8, Offset(U1TXIE_bit+8), 4
;UART1.c,88 :: 		}
L_end_UART1_StartTx:
JR	RA
NOP	
; end of _UART1_StartTx
_InitUART1:
;UART1.c,97 :: 		void InitUART1(void){
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,98 :: 		UART1_SetBaud();
JAL	_UART1_SetBaud+0
NOP	
;UART1.c,99 :: 		UART1_RxQueueInit();
JAL	_UART1_RxQueueInit+0
NOP	
;UART1.c,100 :: 		UART1_TxQueueInit();
JAL	_UART1_TxQueueInit+0
NOP	
;UART1.c,101 :: 		UART1_StartRx();
JAL	_UART1_StartRx+0
NOP	
;UART1.c,102 :: 		}
L_end_InitUART1:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _InitUART1
_UART1_TxQueueInit:
;UART1.c,106 :: 		void UART1_TxQueueInit(void){
;UART1.c,107 :: 		TxQ.TxIn = 0;
SH	R0, Offset(_TxQ+0)(GP)
;UART1.c,108 :: 		TxQ.TxOut = 0;
SH	R0, Offset(_TxQ+2)(GP)
;UART1.c,109 :: 		XmtBufPtr = 0;
SB	R0, Offset(_XmtBufPtr+0)(GP)
;UART1.c,110 :: 		}
L_end_UART1_TxQueueInit:
JR	RA
NOP	
; end of _UART1_TxQueueInit
_UART1_RxQueueInit:
;UART1.c,114 :: 		void UART1_RxQueueInit(void){
;UART1.c,115 :: 		RxQ.RxIn = 0;
SH	R0, Offset(_RxQ+0)(GP)
;UART1.c,116 :: 		RxQ.RxOut = 0;
SH	R0, Offset(_RxQ+2)(GP)
;UART1.c,117 :: 		RcvBufPtr = 0;
SB	R0, Offset(_RcvBufPtr+0)(GP)
;UART1.c,118 :: 		}
L_end_UART1_RxQueueInit:
JR	RA
NOP	
; end of _UART1_RxQueueInit
_UART1_SendMsg:
;UART1.c,122 :: 		void UART1_SendMsg(char *s){
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,123 :: 		XmtBuf = s;           // Pointer to the message for the UART1 interrupt handler
SW	R25, Offset(_XmtBuf+0)(GP)
;UART1.c,124 :: 		XmtBufPtr = 0;        // Set character counter to start of text message
SB	R0, Offset(_XmtBufPtr+0)(GP)
;UART1.c,125 :: 		UART1_StartTx();      // Turn on UART1 transmitter
JAL	_UART1_StartTx+0
NOP	
;UART1.c,126 :: 		}
L_end_UART1_SendMsg:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _UART1_SendMsg
_UART1_CheckQueue:
;UART1.c,133 :: 		void UART1_CheckQueue(void){
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;UART1.c,136 :: 		if ((!U1TXIE_bit)&&(TRMT_bit)){
SW	R25, 4(SP)
_LX	, 4
EXT	R2, R2, BitPos(U1TXIE_bit+0), 1
BEQ	R2, R0, L__UART1_CheckQueue44
NOP	
J	L__UART1_CheckQueue30
NOP	
L__UART1_CheckQueue44:
_LX	, 4
EXT	R2, R2, BitPos(TRMT_bit+0), 1
BNE	R2, R0, L__UART1_CheckQueue46
NOP	
J	L__UART1_CheckQueue29
NOP	
L__UART1_CheckQueue46:
L__UART1_CheckQueue28:
;UART1.c,138 :: 		if (TxQ.TxIn != TxQ.TxOut){      // If pointers are not the same
LH	R3, Offset(_TxQ+2)(GP)
LH	R2, Offset(_TxQ+0)(GP)
BNE	R2, R3, L__UART1_CheckQueue48
NOP	
J	L_UART1_CheckQueue8
NOP	
L__UART1_CheckQueue48:
;UART1.c,139 :: 		UART1_SendMsg(TxQ.TxQueue[TxQ.TxOut++]);  // Hand off the message pointer and increment counter
LH	R2, Offset(_TxQ+2)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_TxQ+4)
ORI	R2, R2, #lo_addr(_TxQ+4)
ADDU	R2, R2, R3
LW	R25, 0(R2)
JAL	_UART1_SendMsg+0
NOP	
LH	R2, Offset(_TxQ+2)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_TxQ+2)(GP)
;UART1.c,140 :: 		if (TxQ.TxOut > (txqsize-1))  // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__UART1_CheckQueue49
NOP	
J	L_UART1_CheckQueue9
NOP	
L__UART1_CheckQueue49:
;UART1.c,141 :: 		TxQ.TxOut = 0;
SH	R0, Offset(_TxQ+2)(GP)
L_UART1_CheckQueue9:
;UART1.c,142 :: 		}
L_UART1_CheckQueue8:
;UART1.c,136 :: 		if ((!U1TXIE_bit)&&(TRMT_bit)){
L__UART1_CheckQueue30:
L__UART1_CheckQueue29:
;UART1.c,144 :: 		}
L_end_UART1_CheckQueue:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _UART1_CheckQueue
_UART1_PutQueue:
;UART1.c,149 :: 		void UART1_PutQueue(char *msg){
;UART1.c,150 :: 		TxQ.TxQueue[TxQ.TxIn++] = msg;      // Enter the message pointer into the queue
LH	R2, Offset(_TxQ+0)(GP)
SLL	R3, R2, 2
LUI	R2, #hi_addr(_TxQ+4)
ORI	R2, R2, #lo_addr(_TxQ+4)
ADDU	R2, R2, R3
SW	R25, 0(R2)
LH	R2, Offset(_TxQ+0)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_TxQ+0)(GP)
;UART1.c,151 :: 		if (TxQ.TxIn > (txqsize-1))         // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 32
BEQ	R2, R0, L__UART1_PutQueue51
NOP	
J	L_UART1_PutQueue10
NOP	
L__UART1_PutQueue51:
;UART1.c,152 :: 		TxQ.TxIn = 0;
SH	R0, Offset(_TxQ+0)(GP)
L_UART1_PutQueue10:
;UART1.c,153 :: 		}
L_end_UART1_PutQueue:
JR	RA
NOP	
; end of _UART1_PutQueue
_UART1_GetChar:
;UART1.c,159 :: 		char UART1_GetChar(char *rxbyte){
;UART1.c,160 :: 		if (RxQ.RxIn != RxQ.RxOut){             // If pointers are not the same
LH	R3, Offset(_RxQ+2)(GP)
LH	R2, Offset(_RxQ+0)(GP)
BNE	R2, R3, L__UART1_GetChar54
NOP	
J	L_UART1_GetChar11
NOP	
L__UART1_GetChar54:
;UART1.c,161 :: 		*rxbyte = RxQ.RxQueue[RxQ.RxOut++];  // Fetch a character from the recirculating buffer
LH	R3, Offset(_RxQ+2)(GP)
LUI	R2, #hi_addr(_RxQ+4)
ORI	R2, R2, #lo_addr(_RxQ+4)
ADDU	R2, R2, R3
LBU	R2, 0(R2)
SB	R2, 0(R25)
LH	R2, Offset(_RxQ+2)(GP)
ADDIU	R2, R2, 1
SH	R2, Offset(_RxQ+2)(GP)
;UART1.c,162 :: 		if (RxQ.RxOut > (rxqsize-1))         // Check for wrap
SEH	R2, R2
SLTI	R2, R2, 64
BEQ	R2, R0, L__UART1_GetChar55
NOP	
J	L_UART1_GetChar12
NOP	
L__UART1_GetChar55:
;UART1.c,163 :: 		RxQ.RxOut = 0;
SH	R0, Offset(_RxQ+2)(GP)
L_UART1_GetChar12:
;UART1.c,164 :: 		return 1;
ORI	R2, R0, 1
J	L_end_UART1_GetChar
NOP	
;UART1.c,165 :: 		}else{
L_UART1_GetChar11:
;UART1.c,166 :: 		return 0;
MOVZ	R2, R0, R0
;UART1.c,168 :: 		}
L_end_UART1_GetChar:
JR	RA
NOP	
; end of _UART1_GetChar
_UART1_Rx:
;UART1.c,172 :: 		void UART1_Rx(void){
ADDIU	SP, SP, -4
SW	RA, 0(SP)
;UART1.c,173 :: 		UART1_RxFuncPtr();        // Use the function pointer to go to a state
LW	R30, Offset(_UART1_RxFuncPtr+0)(GP)
JALR	RA, R30
NOP	
;UART1.c,174 :: 		}
L_end_UART1_Rx:
LW	RA, 0(SP)
ADDIU	SP, SP, 4
JR	RA
NOP	
; end of _UART1_Rx
_UART1_Rx1:
;UART1.c,179 :: 		void UART1_Rx1(void){
ADDIU	SP, SP, -12
SW	RA, 0(SP)
;UART1.c,182 :: 		if (UART1_GetChar(&rxchar)){
SW	R25, 4(SP)
ADDIU	R2, SP, 8
MOVZ	R25, R2, R0
JAL	_UART1_GetChar+0
NOP	
BNE	R2, R0, L__UART1_Rx159
NOP	
J	L_UART1_Rx114
NOP	
L__UART1_Rx159:
;UART1.c,183 :: 		switch (rxchar){
J	L_UART1_Rx115
NOP	
;UART1.c,184 :: 		case NUL:     // Discard NUL character
L_UART1_Rx117:
;UART1.c,185 :: 		break;
J	L_UART1_Rx116
NOP	
;UART1.c,187 :: 		case '\r':    // Discard return character
L_UART1_Rx118:
;UART1.c,188 :: 		break;
J	L_UART1_Rx116
NOP	
;UART1.c,190 :: 		case '\n':    // New line character
L_UART1_Rx119:
;UART1.c,191 :: 		RcvBuf[RcvBufPtr++] = rxchar;     // Put received character into buffer
LBU	R3, Offset(_RcvBufPtr+0)(GP)
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R3, R2, R3
LBU	R2, 8(SP)
SB	R2, 0(R3)
LBU	R2, Offset(_RcvBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_RcvBufPtr+0)(GP)
;UART1.c,192 :: 		RcvBuf[RcvBufPtr] = 0;            // End marker
ANDI	R3, R2, 255
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R2, R2, R3
SB	R0, 0(R2)
;UART1.c,193 :: 		RcvBufPtr = 0;                    // Point to start of buffer
SB	R0, Offset(_RcvBufPtr+0)(GP)
;UART1.c,194 :: 		UART1_RxFuncPtr = UART1_Rx2;      // Go to state 2
LUI	R2, #hi_addr(_UART1_Rx2+0)
ORI	R2, R2, #lo_addr(_UART1_Rx2+0)
SW	R2, Offset(_UART1_RxFuncPtr+0)(GP)
;UART1.c,195 :: 		break;
J	L_UART1_Rx116
NOP	
;UART1.c,197 :: 		default:
L_UART1_Rx120:
;UART1.c,198 :: 		if (RcvBufPtr < (RcvBufSize-2))   // Prevents buffer overrun
LBU	R2, Offset(_RcvBufPtr+0)(GP)
SLTIU	R2, R2, 62
BNE	R2, R0, L__UART1_Rx160
NOP	
J	L_UART1_Rx121
NOP	
L__UART1_Rx160:
;UART1.c,199 :: 		RcvBuf[RcvBufPtr++] = rxchar;  // Put character in buffer
LBU	R3, Offset(_RcvBufPtr+0)(GP)
LUI	R2, #hi_addr(_RcvBuf+0)
ORI	R2, R2, #lo_addr(_RcvBuf+0)
ADDU	R3, R2, R3
LBU	R2, 8(SP)
SB	R2, 0(R3)
LBU	R2, Offset(_RcvBufPtr+0)(GP)
ADDIU	R2, R2, 1
SB	R2, Offset(_RcvBufPtr+0)(GP)
L_UART1_Rx121:
;UART1.c,200 :: 		break;
J	L_UART1_Rx116
NOP	
;UART1.c,201 :: 		}
L_UART1_Rx115:
LBU	R2, 8(SP)
BNE	R2, R0, L__UART1_Rx162
NOP	
J	L_UART1_Rx117
NOP	
L__UART1_Rx162:
LBU	R3, 8(SP)
ORI	R2, R0, 13
BNE	R3, R2, L__UART1_Rx164
NOP	
J	L_UART1_Rx118
NOP	
L__UART1_Rx164:
LBU	R3, 8(SP)
ORI	R2, R0, 10
BNE	R3, R2, L__UART1_Rx166
NOP	
J	L_UART1_Rx119
NOP	
L__UART1_Rx166:
J	L_UART1_Rx120
NOP	
L_UART1_Rx116:
;UART1.c,202 :: 		}
L_UART1_Rx114:
;UART1.c,203 :: 		}
L_end_UART1_Rx1:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 12
JR	RA
NOP	
; end of _UART1_Rx1
_UART1_Rx2:
;UART1.c,207 :: 		void UART1_Rx2(void){
ADDIU	SP, SP, -8
SW	RA, 0(SP)
;UART1.c,210 :: 		switch (RcvBuf[0]){
SW	R25, 4(SP)
J	L_UART1_Rx222
NOP	
;UART1.c,214 :: 		case 'a':
L_UART1_Rx224:
;UART1.c,215 :: 		UART1_PutQueue("ACK\r\n");           // Send an ACK
LUI	R25, #hi_addr(?lstr1_UART1+0)
ORI	R25, R25, #lo_addr(?lstr1_UART1+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,216 :: 		break;
J	L_UART1_Rx223
NOP	
;UART1.c,218 :: 		case 'b':
L_UART1_Rx225:
;UART1.c,219 :: 		UART1_PutQueue("NAK\r\n");           // Send a NAK
LUI	R25, #hi_addr(?lstr2_UART1+0)
ORI	R25, R25, #lo_addr(?lstr2_UART1+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,220 :: 		break;
J	L_UART1_Rx223
NOP	
;UART1.c,222 :: 		case 'c':
L_UART1_Rx226:
;UART1.c,223 :: 		BufNum = GetBuffer();                // Get a free buffer
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;UART1.c,224 :: 		sprintf(BufNum,"%d\r\n",TxQ.TxIn);   // Format the value of TxIn counter
LUI	R4, #hi_addr(?lstr_3_UART1+0)
ORI	R4, R4, #lo_addr(?lstr_3_UART1+0)
LH	R3, Offset(_TxQ+0)(GP)
ADDIU	SP, SP, -12
SH	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;UART1.c,225 :: 		UART1_PutQueue(BufNum);              // Send the buffer
MOVZ	R25, R20, R0
; BufNum end address is: 80 (R20)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,226 :: 		break;
J	L_UART1_Rx223
NOP	
;UART1.c,228 :: 		default:
L_UART1_Rx227:
;UART1.c,229 :: 		UART1_PutQueue("Unknown command: ");
LUI	R25, #hi_addr(?lstr4_UART1+0)
ORI	R25, R25, #lo_addr(?lstr4_UART1+0)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,231 :: 		BufNum = GetBuffer();                // Get a free buffer
JAL	_GetBuffer+0
NOP	
; BufNum start address is: 80 (R20)
MOVZ	R20, R2, R0
;UART1.c,232 :: 		(void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
LUI	R4, #hi_addr(?lstr_5_UART1+0)
ORI	R4, R4, #lo_addr(?lstr_5_UART1+0)
LBU	R3, Offset(_RcvBuf+0)(GP)
ADDIU	SP, SP, -12
SB	R3, 8(SP)
SW	R4, 4(SP)
SW	R2, 0(SP)
JAL	_sprintf+0
NOP	
ADDIU	SP, SP, 12
;UART1.c,233 :: 		UART1_PutQueue(BufNum);
MOVZ	R25, R20, R0
; BufNum end address is: 80 (R20)
JAL	_UART1_PutQueue+0
NOP	
;UART1.c,234 :: 		break;
J	L_UART1_Rx223
NOP	
;UART1.c,235 :: 		}
L_UART1_Rx222:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 97
BNE	R3, R2, L__UART1_Rx269
NOP	
J	L_UART1_Rx224
NOP	
L__UART1_Rx269:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 98
BNE	R3, R2, L__UART1_Rx271
NOP	
J	L_UART1_Rx225
NOP	
L__UART1_Rx271:
LBU	R3, Offset(_RcvBuf+0)(GP)
ORI	R2, R0, 99
BNE	R3, R2, L__UART1_Rx273
NOP	
J	L_UART1_Rx226
NOP	
L__UART1_Rx273:
J	L_UART1_Rx227
NOP	
L_UART1_Rx223:
;UART1.c,236 :: 		UART1_RxFuncPtr = UART1_Rx1;               // Go back to state 1
LUI	R2, #hi_addr(_UART1_Rx1+0)
ORI	R2, R2, #lo_addr(_UART1_Rx1+0)
SW	R2, Offset(_UART1_RxFuncPtr+0)(GP)
;UART1.c,237 :: 		}
L_end_UART1_Rx2:
LW	R25, 4(SP)
LW	RA, 0(SP)
ADDIU	SP, SP, 8
JR	RA
NOP	
; end of _UART1_Rx2
