#line 1 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
#line 1 "c:/users/public/projects/pic/projects/interruptinguart/driverforuart1_code/mikroc pro for pic32/uart1.h"
#line 18 "c:/users/public/projects/pic/projects/interruptinguart/driverforuart1_code/mikroc pro for pic32/uart1.h"
typedef void (*tPointerFcn)(void);
typedef char *pnt;


 typedef struct rx_q_struct
 {
 int RxIn;
 int RxOut;
 char RxQueue[ 64 ];
 }rx_q_struct;


 typedef struct tx_q_struct
 {
 int TxIn;
 int TxOut;
 pnt TxQueue[ 32 ];
}tx_q_struct;




void UART1_SetBaud(void);
void UART1_StartRx(void);
void UART1_StartTx(void);

void InitUART1(void);
void UART1_TxQueueInit(void);
void UART1_RxQueueInit(void);

void UART1_SendMsg(char *s);
void UART1_CheckQueue(void);
void UART1_PutQueue(char *msg);
char UART1_GetChar(char *rxbyte);


void UART1_Rx(void);
void UART1_Rx1(void);
void UART1_Rx2(void);
#line 1 "c:/users/public/projects/pic/projects/interruptinguart/driverforuart1_code/mikroc pro for pic32/buffers.h"
#line 13 "c:/users/public/projects/pic/projects/interruptinguart/driverforuart1_code/mikroc pro for pic32/buffers.h"
char* GetBuffer(void);
#line 11 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
char RcvBuf[ 64 ];
char RcvBufPtr;

char *XmtBuf;
char XmtBufPtr;

rx_q_struct RxQ;
tx_q_struct TxQ;


tPointerFcn UART1_RxFuncPtr = UART1_Rx1;
#line 29 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Interrupt() iv IVT_UART_1 ilevel 7 ics ICS_AUTO {
 char R_data;
 char T_data;

 if (URXDA_bit){
 R_data = U1RXREG;

 RxQ.RxQueue[RxQ.RxIn++] = R_data;
 if (RxQ.RxIn > ( 64 -1))
 RxQ.RxIn = 0;
 U1RXIF_bit = 0;

 }else{
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ){
 U1TXIE_bit = 0;
 }else{
 U1TXREG = T_data;
 U1TXIF_bit = 0;
 }
 }
}
#line 54 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SetBaud(void){

 U1BRG = 520;
}
#line 61 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartRx(void){
 ON__U1MODE_bit = 1;
 URXEN_bit = 1;

 U1IP0_bit = 0;
 U1IP1_bit = 1;
 U1IP2_bit = 1;
 U1IS1_bit = 1;
 U1IS0_bit = 1;

 URXISEL0_bit = 0;
 URXISEL1_bit = 0;

 U1RXIF_bit = 0;
 U1RXIE_bit = 1;
}
#line 80 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_StartTx(void){
 UTXEN_bit = 1;

 UTXISEL0_bit = 0;
 UTXISEL1_bit = 1;

 U1TXIF_bit = 0;
 U1TXIE_bit = 1;
}
#line 97 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void InitUART1(void){
 UART1_SetBaud();
 UART1_RxQueueInit();
 UART1_TxQueueInit();
 UART1_StartRx();
}
#line 106 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_TxQueueInit(void){
 TxQ.TxIn = 0;
 TxQ.TxOut = 0;
 XmtBufPtr = 0;
}
#line 114 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_RxQueueInit(void){
 RxQ.RxIn = 0;
 RxQ.RxOut = 0;
 RcvBufPtr = 0;
}
#line 122 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_SendMsg(char *s){
 XmtBuf = s;
 XmtBufPtr = 0;
 UART1_StartTx();
}
#line 133 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_CheckQueue(void){


 if ((!U1TXIE_bit)&&(TRMT_bit)){

 if (TxQ.TxIn != TxQ.TxOut){
 UART1_SendMsg(TxQ.TxQueue[TxQ.TxOut++]);
 if (TxQ.TxOut > ( 32 -1))
 TxQ.TxOut = 0;
 }
 }
}
#line 149 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_PutQueue(char *msg){
 TxQ.TxQueue[TxQ.TxIn++] = msg;
 if (TxQ.TxIn > ( 32 -1))
 TxQ.TxIn = 0;
}
#line 159 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
char UART1_GetChar(char *rxbyte){
 if (RxQ.RxIn != RxQ.RxOut){
 *rxbyte = RxQ.RxQueue[RxQ.RxOut++];
 if (RxQ.RxOut > ( 64 -1))
 RxQ.RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 172 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx(void){
 UART1_RxFuncPtr();
}
#line 179 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx1(void){
 char rxchar;

 if (UART1_GetChar(&rxchar)){
 switch (rxchar){
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART1_RxFuncPtr = UART1_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 64 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 207 "C:/Users/Public/Projects/PIC/Projects/InterruptingUART/DriverForUART1_Code/mikroC PRO for PIC32/UART1.c"
void UART1_Rx2(void){
 char *BufNum;

 switch (RcvBuf[0]){



 case 'a':
 UART1_PutQueue("ACK\r\n");
 break;

 case 'b':
 UART1_PutQueue("NAK\r\n");
 break;

 case 'c':
 BufNum = GetBuffer();
 sprintf(BufNum,"%d\r\n",TxQ.TxIn);
 UART1_PutQueue(BufNum);
 break;

 default:
 UART1_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART1_PutQueue(BufNum);
 break;
 }
 UART1_RxFuncPtr = UART1_Rx1;
}
